module list.

import javasig, popeyesig.

% Some classical list stuff with continuation
%

type head 		list A -> A -> o -> o.
type tail 		list A -> list A -> o -> o.
type isnil		list A -> o -> o.

type build		list A -> A -> list A -> o -> o.

type delete   	      	list A -> A -> list A -> o -> o.
type memb		list A -> A -> o -> o.
type lmemb		list A -> A -> o -> o.
type memb_replace	list A -> A -> A -> list A -> o -> o.
type append		list A -> list A -> list A -> o -> o.

type reverse		list A -> list A -> o -> o.

% Basic stuff
%
head nil null G :- G.
head (X::L) X G :- G.

tail nil nil G :- G.
tail (X::L) L G :- G.

isnil nil G :- G.
build L X (X::L) G :- G.

% Append two lists
%
append nil K K G :- G.
append (X :: L) K (X :: M) G :- append L K M G.

% Check if an element is a member of a list
%
memb (X::L) X G :- G.
memb (Y::L) X G :- memb L X G.

% Check if an element is a member of a list and returns the leftmost match
% if multiple bindings exist
lmemb L X G :- memb L X G, !, G.

% Replace an element
%
memb_replace nil X Y nil G :- G.
memb_replace (X::L) X Y (Y::P) G &
memb_replace (Z::L) X Y (Z::P) G :- !,memb_replace L X Y P G.

% Delete an element
%
delete nil _ nil G :- G.
delete (X::L) X     K  G &
delete (Y::L) X (Y::K) G :- !, delete L X K G.

% Reverse a list
%
reverse L K G :- ( pi rv\
	        (( rv nil K,
    	           pi X\(pi N\(pi M\( 
	           rv (X::N) M :- rv N (X::M))))) => rv L nil) ), G.


% Popeye version of the above functions

type poplist 	class.
type lplist 	ref .

type get_list 	ref -> list ref -> cmd.
type set_list 	ref -> list ref -> cmd.

type pophead 	ref -> ref -> cmd.
type poptail 	ref -> ref -> cmd.
type popisnil	ref -> ref -> cmd.
type popbuild   ref -> ref -> cmd.
type popappend	ref -> ref -> cmd.
type popdelete	ref -> ref -> cmd.
type popreverse	ref -> cmd.

type val 	list A -> ref.

popmod ( poplist ) (

	L\

	poploc "" poplist lplist lplist\

	( popcon 	((pv lplist (val nil))::nil)
		(
			( cons L (poplist) >- empty 		) ::

			( poppi "" LPL\
			  get_list L LPL >- rw lplist (val LPL) (val LPL) ) ::

			( poppi "" LPL\ poppi "" NewLPL\
			  set_list L NewLPL >- rw lplist (val LPL) (val NewLPL) ) ::

			( poppi "" H\ poppi "" LPL\
			  pophead L H >- rw lplist (val LPL) (val LPL) >>
					 lamb (head LPL H)	    	) ::		
	
			( poppi "" T\ poppi "" LPL\ poppi "" LPT\
			  poptail L T >- rw lplist (val LPL) (val LPL) >>
					 lamb (tail LPL LPT)	   >>
					 set_list T LPT		) ::

			( poppi "" LPL\
			  popisnil L I >- rw lplist (val LPL) (val LPL) >>
				     	  lamb (isnil LPL) +> (I == (pbool poptrue) )
					  		   |> (I == (pbool popfalse) ) 
									    ) ::

			( poppi "" H\ poppi "" LPL\ poppi "" NewLPL\
			  popbuild L H >- rw lplist (val LPL) (val LPL)  >>
					  lamb (build LPL H NewLPL) >>
					  rw lplist (val LPL) (val NewLPL)   ) :: 
					  			
			( poppi "" P\ poppi "" LPL1\ poppi "" LPL2\ poppi "" NewLPL\
			  popappend L P >- rw lplist (val LPL1) (val LPL1)     >>
					   get_list P LPL2     	   >>
					   lamb (append LPL1 LPL2 NewLPL) >>
					   rw lplist (val LPLL1) (val NewLPL)     ) ::

			( poppi "" Elem\ poppi "" NewL\ poppi "" LPL\
			  popdelete L Elem >- rw lplist (val LPL) (val LPL)	     >>
					      lamb (delete LPL Elem NewLPL) >>
					      rw lplist (val LPL) (val NewLPL)    ) :: 
			
			( poppi "" NewL\ poppi "" LPL\ poppi "" NewLPL\ 
			  popreverse L >- rw lplist (val LPL) (val LPL)	>>
					  lamb (reverse LPL NewLPL) 	>>
					  rw lplist (val LPL) (val NewLPL) ) ::

			nil
		)
	)
).
					
