module spinach.

import popeyesig, typechecker, list.

kind npair	type.	
type np		Any -> string -> npair.			% For the names list.

type spinach 	list ptpair -> list npair -> Any -> string -> o.
type spitest	list ptpair -> list npair -> Any -> string -> o.
type spihead 	list ptpair -> list npair -> Any -> list Bny -> string -> string -> o.
type spidecl	list ptpair -> list npair -> list Any -> string -> o.
type spiparams 	list ptpair -> list A -> o.

type tspinach 	list Any -> list Bny -> string -> pt.

% Built in stuff
%
% Booleans
%
spinach Theta Mu popbool "boolean".
spinach Theta Mu (pbool poptrue) "true".
spinach Theta Mu (pbool popfalse) "false".

% Integers
%
spinach Theta Mu popint "int".
spinach Theta Mu (pint I) J :- 
	term_to_string I J.

% Object
%
spinach Theta Mu (tref object) "Object".
spinach Theta Mu null "null".

% Spinach
%
spinach Theta Mu P Java :-
	lmemb Mu (np P Java) top.

% Init
%
spinach Theta Mu (init A V) Java :-
	spinach Theta Mu A JA,
	spinach Theta Mu V JV,
	Java is JA ^ " = " ^ JV ^ ";\n".

% Rw
%
spinach Theta Mu (rw A O N) Java :-
	spinach Theta Mu A JA,
	spinach Theta Mu O JO,
	spinach Theta Mu N JN,
	Java is JO ^ " = " ^ JA ^ ";\n" ^ JA ^ " = " ^ JN ^ ";\n".

spitest Theta Mu (rw A O O) Java :-
	spinach Theta Mu A JA,
	spinach Theta Mu O JO,
	Java is JO ^ " == " ^ JA.

% ==
%
spinach Theta Mu (A == B) Java :-
	print "!!!",
	spinach Theta Mu A JA,
	spinach Theta Mu B JB, 
	Java is JA ^ " = " ^ JB ^ ";\n".

spitest Theta Mu (A == B) Java :-
	print "!!!",
	spinach Theta Mu A JA,
	spinach Theta Mu B JB,
	Java is JA ^ " == " ^ JB.

% Empty
%
spinach Theta Mu empty "".

% Senseless
%
spitest Theta Mu empty "DUMMY TEST".

% Cast
%
spinach Theta Mu (cast A T) "".

% Cont
%
spinach Theta Mu (A >> B) Java :-
	spinach Theta Mu A JA,
	spinach Theta Mu B JB,
	Java is JA ^ JB.

% Branch
%
spinach Theta Mu (A +> B |> C) Java :-
	spitest Theta Mu A JA,
	spinach Theta Mu B JB,
	spinach Theta Mu C JC,
	Java is "if ( " ^ JA ^ " ){\n" ^ JB ^ "}\n" ^ "else{\n" ^ JC ^ "}\n".

% Clause
%
spinach Theta Mu (poppi S P) Java :-
	pi C\ spinach ((tp C dot)::Theta) ((np C S)::Mu) (P C) Java.

spinach Theta Mu (A >- B) Java :-
	spihead Theta Mu A HeadParams Jhead Jreturn,
	spiparams Theta AddParams,
	append HeadParams AddParams Params top,
	tcheck Theta (A >- B) (empty::nil) tclause ((tspinach Mu Params Jdecl)::nil), 	
	spinach Theta Mu B Jbody,
	Java is Jhead ^ Jdecl ^ Jbody ^ Jreturn ^ "}\n".
		
tcheck Theta empty Cont (tspinach Mu Params Jdecl) TC :-
	spidecl Theta Mu Params Jdecl,
	tcheck Theta none Cont dot TC.	

spiparams nil nil.
spiparams ((tp M dot)::Theta) Params    & 
spiparams ((tp M C)::Theta) (M::Params) :- !, spiparams Theta Params.

% Program
%	
spinach Theta Mu (Clause::Prog) Java :-
	spinach Theta Mu Clause JC,
	spinach Theta Mu Prog JP,
	Java is JC ^ JP.

spinach Theta Mu nil "".

% Private
%
spinach Theta Mu (poploc S C D P) Java :-
	tcheck Theta (ppriv C D) nil Tau nil,
	spinach nil nil Tau JT,
	pi E\ spinach ((tp E Tau)::Theta) ((np E S)::Mu) (P E) JP,
	Java is JT ^ " " ^ S ^ ";\n" ^ JP.

% Constant
%
spinach Theta Mu (popsta S C N V P) Java :-
	tcheck Theta V nil Tau nil,
	spinach nil nil Tau JT,
	spinach nil nil V JV,
	spinach ((tp (pcst C N) Tau)::Theta) ((np (pcst C N) S)::Mu) P JP,
	Java is "public static " ^ JT ^ " " ^ S ^ " = " ^ JV ^ ";\n" ^ JP.

% Context
%  
spinach Theta Mu (popcon Lin Prog) Java :- 
	spinach Theta Mu Prog Java.
	
% Declarations
%
spidecl Theta ((np N S)::Mu) List Jdecl :-
	lmemb List N top,
	spidecl Theta Mu List Jdecl.

spidecl Theta ((np N S)::Mu) List Jdecl :-
	not ( lmemb List N top ),	
	lmemb Theta (tp N T) top,
	spinach nil nil T ST,
	spidecl Theta Mu List Jrest,
	Jdecl is ST ^ " " ^ S ^ ";\n" ^ Jrest.		  
	 
spidecl Theta nil List "".










